﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication123;
using Syncfusion.JavaScript.Models;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
namespace SyncfusionMvcApplication123.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            
       
            List<Column> column = new List<Column>();
              column.Add(new Column()  
                {  
                Field = "OrderID",
                HeaderText="OrderID",
                AllowEditing= true,
                AllowFiltering= true,
                AllowSorting= true
                });
              column.Add(new Column()
              {
                  Field = "CustomerID",
                  HeaderText = "CustomerID",
                  AllowEditing = true,
                  AllowFiltering = true,
                  AllowSorting = true
              });
              column.Add(new Column()
              {
                  Field = "ShipCity",
                  HeaderText = "ShipCity",
                  AllowEditing = true,
                  AllowFiltering = true,
                  AllowSorting = true
              });
              ViewBag.col = column;
              return View();
        }
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = new NorthwindDataContext().OrdersViews.ToList();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.result = DataSource;
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                result.result = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                result.result = operation.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
            }
            result.count = result.result.AsQueryable().Count();
            if (dm.Skip > 0)
                result.result = operation.PerformSkip(result.result, dm.Skip);
            if (dm.Take > 0)
                result.result = operation.PerformTake(result.result, dm.Take);
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }
}
